package klax;

import java.awt.Color;
import java.awt.Graphics;

/**
 * @author Christian Grfe
 * 
 * Ein Spielstein
 */

public class JavaKlax_Stein extends JavaKlax_GameObjekt
{
	/** Hhe eines Steines */
	public static final byte hoehe=16;
	/** Breite eines Steines */
	public static final byte breite=60;
	
	/** Die Farbe die ein Stein annehmen kann */
	private static final Color c[][]={ {Color.RED,Color.GREEN,Color.BLUE,
	        							Color.CYAN,Color.YELLOW,Color.MAGENTA,
	        							Color.GRAY, Color.WHITE, new Color(255,165,0)},
	        							{new Color(128,0,0),new Color(0,128,0),new Color(0,0,128),
	        							 new Color(0,128,128),new Color(128,128,0), new Color(128,0,128),
	        							 Color.DARK_GRAY, Color.LIGHT_GRAY, new Color(255,140,0)}
	        						};
	
    /** Die Farbe des Steines */
    private byte color;
    
    /** Die Spalte in der sich der Stein befindet */
    private byte spalte;
    
    /**
     * Der Kunstruktor eines Steines
     * @param c gibt die Farbnummer an
     * @param y gibt die Y-Position an
     * @param spalte gibt die Spaltennummer an
     */
    public JavaKlax_Stein(byte c, int y, byte spalte)
    {
    	setPos(y,spalte);
        color=c;
    }
    
    /**
     * Mit dieser Funktion wird die Position des Steines auf
     * dem Spielfeld verndert
     * @param y -> die Y-Position auf dem Spielfeld
     * @param spalte -> die Y-Position auf dem Spielfeld
     */
    public void setPos(int y, byte spalte)
    {
        this.y=y;
        setSpalte(spalte);
    }
    
    /** setzt die Y-Position des Steines */
    public void setY(int y)
    {
    	this.y=y;
    }
    
    /** setzt die Spalte in der der Stein ist */
    public void setSpalte(byte spalte)
    {
    	this.spalte=spalte;
    	// x Position aus spalte berechnen
    	x=leftX+4+spalte*(breite+6);
    }
    
    /** gibt die Spalte in der der Steines ist zurck */
    public byte getSpalte()
    {
    	return spalte;
    }
    
    /** gibt die FarbNummer des Steines zurck */
    public byte getColor()
    {
        return color;
    }
    
    /** zeichnet den Stein */
    public void draw(Graphics g)
    {
        g.setColor(c[0][this.color]);
        g.fillRect(x,y,breite-1,hoehe-1);
        g.setColor(c[1][this.color]);
        g.drawRect(x,y,breite-1,hoehe-1);
    }
}
